# Code written by: 
# Juho Kopra / juho.j.kopra@jyu.fi / University of Jyväskylä, Finland / 20th April 2017

# code to find model parameters from text string
stripVariablesFromModelFile <- function(modelAsString) {
  # Tämä versio osaa ottaa sekä muuttujat muotoa variable[i] ~ että variable ~ , mutta ei muotoa variable[indexv[i]] ~
  tmp <- gregexpr(pattern="([A-Za-z\\.\\_]*)\\[[A-Za-z1-9\\.\\_]+\\]\\s+~\\s+|([A-Za-z\\.\\_]+)\\s+~\\s+",modelAsString,perl=TRUE)
  return( unique(gsub(pattern="\\[[A-Za-z1-9\\.\\_]*\\]\\s+~.*|\\s+~.*",replacement="",x=regmatches(x=modelAsString,m=tmp)[[1]])) )
}

# use with other non-stochastic parameters asked as well
#union(stripVariablesFromModelFile(model),c("M","F.pro"))

quantiles <- function(x,prob=c(0.025,0.5,0.975),names,round.by=5,add.mean=TRUE) {
  #user can use names, if he wishes or leave names NULL or "all" having same effecr
  if (is.null(names) | names[1] == "all" | names[1] == "") { names <- colnames(x); }
  #select by names
  whichAre <- vector("integer",length(names))
  for(i in 1:length(names)) { tmpInt <- which(colnames(x) == names[i]); if (length(tmpInt)) {whichAre[i] <- tmpInt; }; }

  resArr <- array(NA,dim=c(length(prob),length(names[whichAre>0])))
  colnames(resArr) <- names[whichAre>0]
  rownames(resArr) <- paste(prob,"%",sep=" ")
  
  whichAre <- whichAre[whichAre > 0]

  #lets do quantiles
  for(i in 1:length(whichAre)) {
    resArr[,i] <- round(quantile(x=x[,whichAre[i]],prob=prob),round.by)
  }
  resArr <- t(resArr)
  if(add.mean) {
    resArr <- cbind("mean"=round(colMeans(x)[rownames(resArr)],round.by),resArr)
  }
  return (resArr)
}

