# Code written by: 
# Juho Kopra / juho.j.kopra@jyu.fi / University of Jyväskylä, Finland / 20th April 2017
rm(list=ls())
setwd("/set/your/own/path/kopra_etal_codes/") # Set a local folder

n.chains = 7
n.strata = 51

coda.samples.reload <- function(j) {
    # i: which strata (=temprorary saving) you want to load
    i <- n.strata
    load(file=paste("./runs/chain-",j,"/images/image",i,"chain",j,".Rdata",sep=""))
#    out.res[[1]]<-out.res[[1]][,-grep("part",colnames(out.res[[1]]))]
#    save(out.res,time.updates,time.burnin,time.coda,time.initial,file=paste("./runs/chain-",j,"/images/image",i,"chain",j,".Rdata",sep=""))
    out.res
}

par.samples.final = lapply(1:n.chains, coda.samples.reload)
##Reorganize 'par.samples' so that it is recognizeable as an 'mcmc.list' object
for(i in 1:length(par.samples.final)) { par.samples.final[[i]] <- par.samples.final[[i]][[1]] }
class(par.samples.final) <- "mcmc.list"
save.image(file="results_out.Rdata")

library(rjags)
summary(par.samples.final)

pdf(file="all_parametres.pdf",width=16,height=10)
plot(par.samples.final)
dev.off()
file.show("all_parametres.pdf")

gelman.diag(par.samples.final,autoburnin=FALSE,multivariate = FALSE)

