# Code written by: 
# Juho Kopra / juho.j.kopra@jyu.fi / University of Jyväskylä, Finland / 20th April 2017
rm(list=ls())

setwd("/set/your/own/path/kopra_etal_codes/") # Set a local folder

# ----------------- COMMENTS ------------------- #
# This is master file executing analysis code. To fully run this with 7 chains in parallel, one needs an access (via ssh connection) to cluster computer with R, R-package Rmpi and JAGS 3.4.0 (or possibly newer) installed.
# ---------------------------------------------- #

model_specific_folder<-"chain"
never_rm<-c("model_name","date","minimal","prerun","model_specific_folder","never_rm","id_rank")

# Next build model specific folders
{
  id_rank <- 1
  proposed<-paste(getwd(),"/runs/",model_specific_folder,"-",id_rank,sep="",collapse="")
  if (!dir.exists(proposed)) {
     dir.create(proposed)
  }
  if (!dir.exists(paste(proposed,"/images",sep="",collapse=""))) {
     dir.create(paste(proposed,"/images",sep="",collapse=""))
  }
  model_specific_folder<-paste(model_specific_folder,"-",id_rank,sep="",collapse="")
}

# lets fit a model
{
  source("./codes/minimal_runs/minimal_smokingdata_simulationfit_jags_model5.r")
  rm(list=setdiff(ls(),never_rm))
  print(paste(c("id:",id_rank," Minimal run has been fitted."),collapse=" "))
}
